DEFDBL B-E
PRINT
PRINT "To calculate LBethe from eq. (3.15) of ICRU Report 2004"
PRINT
'Note: the relativistic calculation of beta is correct down to EoverA=1E-7,
'if the projectile mass A1 is entered in u!
'Program based on L-CONV3.BAS

INPUT "Enter mass number and element symbol of projectile (e.g.,16, O): "; A1$, Proj$
A1 = VAL(A1$)

OPEN "Projs.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)                        'Find Z1
        INPUT #5, Z1, ProjList$
        IF Proj$ = ProjList$ THEN EXIT DO
        IF Z1 = 93 THEN PRINT "No projectile name found"
LOOP
CLOSE

OPEN "Masses.lst" FOR INPUT AS #6    'Rest Energies of Projectiles in MeV
INPUT #6, Heading$
DO WHILE NOT EOF(6)
         INPUT #6, Z1L, A1L, E0         'To find E0
         IF Z1L <> Z1 THEN GOTO there:
         IF A1L <> A1 THEN GOTO there:  ELSE EXIT DO
there:  LOOP
CLOSE #6

                                    'To find Z2:
INPUT "Enter element symbol of target (e.g., C, N2, etc.) : "; Targ$
OPEN "Targets.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)
        INPUT #5, Z2, TargList$
        IF Targ$ = TargList$ THEN EXIT DO
        IF Z2 = 140 THEN PRINT "No target name found"
LOOP
CLOSE

INPUT "Enter I-value of target in eV : "; I

OPEN "atdata.txt" FOR INPUT AS #5        'Find A2
LINE INPUT #5, Heading$
LINE INPUT #5, Heading$
DO WHILE NOT EOF(5)
        INPUT #5, Z, C1, C2, A2, C3, C4  'Find rel. at. mass of natural element
        IF Z = Z2 THEN EXIT DO
LOOP

OutFile$ = "L" + Proj$ + Targ$ + ".Bet"

OPEN OutFile$ FOR OUTPUT AS #2

EoverA = .0001                              'E/A in MeV
DO WHILE NOT EoverA > 100
                              
        E = E0 + EoverA * A1                'Double Precision!
        beta = SQR(1 - (E0 / E) ^ 2)        'relativistic
        L = LOG(2 * 510999 * beta ^ 2 / I) - LOG(1 - beta ^ 2) - beta ^ 2
                                                        'eq. (3.15)
        PRINT USING "###.#######  "; EoverA; L
        PRINT #2, USING "###.#######  "; EoverA; L
        EoverA = EoverA * 1.3
LOOP
END

